#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed May 18 06:03:24 2022

@author: tanu
"""
#cv = rskf_cv
cv = skf_cv

# SVC: Feature Selelction + GridSearch CV + Pipeline
###############################################################################
# Define estimator
estimator =  SVC(**rs)

# Define pipleline with steps
pipe_svc = Pipeline([
    ('pre', MinMaxScaler())
    , ('fs', RFECV(DecisionTreeClassifier(**rs), cv = cv, scoring = 'matthews_corrcoef'))
#    , ('fs', RFECV(estimator, cv = cv, scoring = 'matthews_corrcoef'))
    , ('clf',  estimator)
    ])

# Define hyperparmeter space to search for
param_grid_svc = [
    {
    'fs__min_features_to_select' : [1,2]
#     , 'fs__cv': [cv]
     },
             
    {
#        'clf': [SVC(**rs)],    
        'clf__kernel': ['poly', 'rbf', 'sigmoid']
        #, 'clf__kernel': ['linear']
       , 'clf__C'    : [50, 10, 1.0, 0.1, 0.01]
       , 'clf__gamma': ['scale', 'auto'] 
        
        }
]

# Define GridSearch CV
gscv_fs = GridSearchCV(pipe_svc
                   , param_grid_svc
                   , cv = cv
                   , scoring = mcc_score_fn
                   , refit = 'mcc'
                   , verbose = 3
                   , return_train_score = True
                   , **njobs)
###############################################################################
#------------------------------
# Fit gscv containing pipeline
#------------------------------
gscv_fs.fit(X, y)

#Fitting 10 folds for each of 4 candidates, totalling 80 fits
# QUESTION: HOW??
gscv_fs.best_params_
gscv_fs.best_score_

# Training best score corresponds to the max of the mean_test<score>
train_bscore = round(gscv_fs.best_score_, 2); train_bscore
print('\nTraining best score (MCC):', train_bscore)
round(gscv_fs.cv_results_['mean_test_mcc'].max(),2)

# Training results
gscv_tr_resD = gscv_fs.cv_results_
mod_refit_param =  gscv_fs.refit

# sanity check
if train_bscore == round(gscv_tr_resD['mean_test_mcc'].max(),2):
    print('\nVerified training score (MCC):', train_bscore )
else:
    print('\nTraining score could not be internatlly verified. Please check training results dict')

# Blind test: REAL check!
tp = gscv_fs.predict(X_bts)
print('\nMCC on Blind test:'     , round(matthews_corrcoef(y_bts, tp),2))
print('\nAccuracy on Blind test:', round(accuracy_score(y_bts, tp),2))

############
# info extraction
############
# gives input vals??
gscv_fs._check_n_features

# gives gscv params used
gscv_fs._get_param_names()

# gives ??
gscv_fs.best_estimator_
gscv_fs.best_params_ # gives best estimator params as a dict 
gscv_fs.best_estimator_._final_estimator # similar to above, doesn't contain max_iter
gscv_fs.best_estimator_.named_steps['fs'].get_support()
gscv_fs.best_estimator_.named_steps['fs'].ranking_ # array of ranks for the features

gscv_fs.best_estimator_.named_steps['fs'].grid_scores_.mean()
gscv_fs.best_estimator_.named_steps['fs'].grid_scores_.max()
#gscv_fs.best_estimator_.named_steps['fs'].grid_scores_

###############################################################################
#============
# FS results
#============
# Now get the features out
all_features = gscv_fs.feature_names_in_
n_all_features =  gscv_fs.n_features_in_
#all_features = gsfit.feature_names_in_

sel_features = X.columns[gscv_fs.best_estimator_.named_steps['fs'].get_support()]
n_sf = gscv_fs.best_estimator_.named_steps['fs'].n_features_

# get model name
model_name  = gscv_fs.best_estimator_.named_steps['clf']
b_model_params = gscv_fs.best_params_

print('\n========================================'
      , '\nRunning model:'
      , '\nModel name:', model_name
      , '\n==============================================='
      , '\nRunning feature selection with RFECV for model'
      , '\nTotal no. of features in model:', len(all_features)
      , '\nThese are:\n',  all_features, '\n\n'
      , '\nNo of features for best model: ', n_sf
      , '\nThese are:', sel_features, '\n\n'
      , '\nBest Model hyperparams:', b_model_params
      )

###############################################################################
############################## OUTPUT #########################################
###############################################################################
#=========================
# Blind test: BTS results
#=========================
# Build the final results with all scores for a feature selected model
bts_predict = gscv_fs.predict(X_bts)
print('\nMCC on Blind test:'     , round(matthews_corrcoef(y_bts, bts_predict),2))
print('\nAccuracy on Blind test:', round(accuracy_score(y_bts, bts_predict),2))

# create a dict with all scores
lr_btsD = {#'best_model': list(gscv_lr_fit_be_mod.items())
               'bts_fscore':None
               , 'bts_mcc':None
               , 'bts_precision':None
               , 'bts_recall':None
               , 'bts_accuracy':None
               , 'bts_roc_auc':None
               , 'bts_jaccard':None }
lr_btsD
lr_btsD['bts_fscore']    = round(f1_score(y_bts, bts_predict),2)
lr_btsD['bts_mcc']       = round(matthews_corrcoef(y_bts, bts_predict),2)
lr_btsD['bts_precision'] = round(precision_score(y_bts, bts_predict),2)
lr_btsD['bts_recall']    = round(recall_score(y_bts, bts_predict),2)
lr_btsD['bts_accuracy']  = round(accuracy_score(y_bts, bts_predict),2)
lr_btsD['bts_roc_auc']   = round(roc_auc_score(y_bts, bts_predict),2)
lr_btsD['bts_jaccard']   = round(jaccard_score(y_bts, bts_predict),2)
lr_btsD

#===========================
# Add FS related model info
#===========================
output_modelD = {'model_name': model_name
                 , 'model_refit_param': mod_refit_param
                 , 'Best_model_params': b_model_params 
                 , 'n_all_features': n_all_features
                 , 'fs_method': gscv_fs.best_estimator_.named_steps['fs'] # FIXME: doesn't tell you which it has chosen
                 , 'fs_res_array': gscv_fs.best_estimator_.named_steps['fs'].get_support()
                 , 'fs_res_array_rank': gscv_fs.best_estimator_.named_steps['fs'].ranking_
                 , 'all_feature_names': all_features
                 , 'n_sel_features': n_sf
                 , 'sel_features_names': sel_features
                 , 'train_score (MCC)': train_bscore}
output_modelD

#========================================
# Update output_modelD with bts_results
#========================================
output_modelD.update(lr_btsD)
output_modelD

#========================================
# Write final output file
# https://stackoverflow.com/questions/19201290/how-to-save-a-dictionary-to-a-file
#========================================
# output final dict as a json
# outFile = 'LR_FS.json'
# with open(outFile, 'w') as f:
#     json.dump(output_modelD, f)
# #
# with open(file, 'r') as f:
#     data = json.load(f)